/*
	Copyright (C) 2003 Frdric Giudicelli (contact_nos@yahoo.com). 
	All rights reserved.

	This product includes cryptographic software written by Eric Young
	(eay@cryptsoft.com)

	This program is released under the GPL with the additional exemption that
	compiling, linking, and/or using OpenSSL is allowed.

	This program is free software; you can redistribute it and/or modify it
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2 of the License.

	This program is distributed in the hope that it will be useful, but WITHOUT
	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
	FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
	more details.

	You should have received a copy of the GNU General Public License along with
	this program; if not, write to the Free Software Foundation, Inc., 59 Temple
	Place, Suite 330, Boston, MA 02111-1307 USA
*/

// CA.h: interface for the CA class.
//
//////////////////////////////////////////////////////////////////////

#ifndef PKI_AUTH_MOD_H
#define PKI_AUTH_MOD_H


/*!
  This structure lists the callback functions
  returned by an authentication plugin.
*/
typedef struct md_MOD_AUTH_FUNC
{
	int (*login)(const char * datas, const char * username, const char * password); //!< Function is called to authenticate an user
	int (*validate_username)(const char * datas, const char * username); //!< Function is called to verify that a username is valid
}MOD_AUTH_FUNCS;


typedef MOD_AUTH_FUNCS * (*GET_FUNCTIONS_LIST)();	 //!< Function is called to get the list of functions

#endif
